package model;

import java.util.HashSet;
import java.util.ArrayList;
import java.util.Iterator;


/**This class collects some general information which is needed at several points in the model.
 * It has been partly modified by Marvin Nebel for the Satisficing version (Modifcations are marked)
 *
 * @author gholtz, (Marvin Nebel)
 * 
 *
 */
public class GlobalVariables{

	public static String subDir = "";
	public static String modelOutputPath = "/home/student/m/mnebel/Simulationen/optimizing/";
	public static String dataFileExtension = ".mr";
	
	public static double UAA = 245000; //ha
	public static double labourCosts = 9000; //Euro/AWU
	public static double waterPrice = 0.045; // Euro/m^3;
	public static boolean DIFFUSION = true;
	//Enable scenarios with and without irrigation
	public static boolean IRRIGATION = true;
	
	//Inserted by Marvin Nebel: An applied view to the satisficing model in repast
	public static boolean SATISFICING_DISPLAY = true;
	
	//Inserted by Marvin Nebel: Defines, whether the satisficing concept is applied to the farm types or not
	public static boolean [] SATISFICING_PER_TYPE = {true, true, true};
	
	//Inserted by Marvin Nebel: Defines, whether land-use patterns including options of marginal sizes 
	// should be included in the decision-making process or not
	public static boolean DISCARDSMALLPATTERN = true;

	
	public static int init = 0;
	
/*	//priorities
	public static double gmShapeFactor = 1.0;
	public static double riskShapeFactor = 1.0;
	public static double legalShapeFactor = 1.0;
	public static double labourShapeFactor = 0.1;
	//sets absolute labour limit relative to labour force
	public static double labourLimitFactor = 1.5;
	public static double prefLabourAdjustmentRate = 0.0;
	
	//distance factors
	public static double skillsShapeFactor = 1.0;
	public static double capitalShapeFactor = 1.0;
*/	
	public static double maxWaterUse;

/*	
	protected static double refRiskSmall;
	protected static double refRiskBig;
*/	
	protected static int nrFarmersModelPerSizeClass = 100;
	protected static int[] nrFarmersReal = {8000,6000,2000,800,300};
	
/*	public static int nrFarmers(int type){
		return nrFarmersModel[type];
	}
*/	
	public static int nrFarmersModel(){
		
		return nrFarmersModelPerSizeClass*5;
	}
	public static double scalingFactor(int farmerSizeClass){
		return ((double)nrFarmersReal[farmerSizeClass])/nrFarmersModelPerSizeClass;
	}
		
/*	public static double getDistanceSkillShape(){
		return distanceSkillsShape;
	}
	
	public static void setDistanceSkillsShape(double v){
		distanceSkillsShape = v;
	}
	
	public static double getDistanceCapitalShape(){
		return distanceCapitalShape;
	}
	
	public static void setDistanceCapitalShape(double v){
		distanceCapitalShape = v;
	}
	
	public static void setIncomeFactor(double v){
		gmFactor = v;
	}
	public static void setRiskFactor(double v){
		riskFactor = v;
	}
	public static void setLegalFactor(double v){
		legalFactor = v;
	}
	public static void setLabourShape(double v){
		labourShape = v;
	}
	
	public static void setLabourLimitFactor(double v){
		labourLimitFactor = v;
	}
*/	
	public static void setWaterPrice(double v){
		waterPrice = v;
	}
	
	public static void setLabourCosts(double v){
		labourCosts = v;
	}
	
	
	public static void setUp(ArrayList<Farmer>farmers, ArrayList<Option>options){
			
		//extract sizes of farms
		Iterator<Farmer> itF = farmers.iterator();
		Farmer f;
		HashSet<Double> sizes = new HashSet<Double>();
		while(itF.hasNext()){
			f = itF.next();
			sizes.add(new Double(f.sizeOfFarm));	//adds only if not already present		
		}
		
		//extract max water use
		Iterator<Option> itO = options.iterator();
		while(itO.hasNext()){
			 Farming o = (Farming) itO.next();
			 if(o.waterUsePerHa() > maxWaterUse){
				 maxWaterUse = o.waterUsePerHa();
			 }
		}	
	}
	

	public static String getSubDir(){
		return subDir;
	}
	
	public static void setSubDir(String s){
		subDir = s;
	}
	
	public static String getOutputDir(){
		return modelOutputPath.concat(subDir);
	}
}
