package model;

/**A LandUse combines an Option and an area assigned to this Option. 
 * @author Georg
 *
 */
public class LandUse{

	/**Creates an exact copy of l (clones l.option (in case options change over time), copies l.size).
	 * 
	 * @param l
	 * @return
	 */
	public static LandUse clone(LandUse l){
		
		LandUse c = new LandUse();
		c.option = l.option.clone();
		c.size = l.size;	
		
		return c;
	}
	
	public double size; //size of area (in ha) used for this type of land use
	public Option option; //the Option for which this land use is utilised.
//	public int age; //Age of land-use not considered in this model yet.
	
	/**Returns the name of the this.option.*/
	public String getName(){
		return option.getName();
	}
	
	/**Returns true if this.option.equals(l.option).*/
	public boolean equalOption(LandUse l){
		if(l.option.equals(this.option)){
			return true;
		}
		return false;
	}	
	
	/**Returns true if this.option.equals(l.option).*/
	public boolean equals(LandUse l){
		if(equalOption(l)&&(l.size == this.size)){
				return true;
		}
		return false;
	}	
}
