package model;

/**The Option interface defines information that must be given 
 * about something a farmer can do with his land. Most prominent 
 * Options are Farming-Options but other Options could be included 
 * in principle.
 * @author gholtz
 */ 

public interface Option {
	
	public double incomePerHa(double size);
	public double costsPerHa(double size);
	public double labourPerHa(double size);
	public double waterUsePerHa();
	public void setUses(int u);
	public int getUses();
	public Option clone();
	public boolean equals(Option o);
	public String getName();
}
