package model.decisionMaking;

import java.util.ArrayList;

import model.Option;
import model.Farmer;

/**This class implements a simple version of the CollectOptions interface. All Options which 
 * are specified in a call of setAllOptions(..) are considered by each Farmer.
 * @author gholtz
 *
 */
public class CollectOptions_allOptions implements CollectOptions {

	protected ArrayList<Option> options;
//	protected Option[] allOptions;
	
	/**Returns the list l given in setAllOptions(...) independent of f.
	 * l is not cloned, therefore changes outside this class may effect the result.*/
	public Option[] collectOptionsForFarmer(Farmer f) {
		
		Option[] allOptions = new Option[options.size()];
		
		for(int i=0; i<options.size(); i++){
			allOptions[i] =  options.get(i);
		}
		
		return allOptions;
	}
	
	public void setAllOptions(ArrayList<Option> l){
		
		options = l;
//*debug*/System.err.println("CollectOptions:setting options:"+l);
		
		
	}
}
