package model.rules;


import model.*;
import model.decisionMaking.EvaluatedLandUsePattern;


public class CapPrices extends Rule {

	protected int baseYear = 1991;	//before 1991 prices remain same, then yearly adaptation
	protected double tradCerealPrices[] = {21.0,21.0,18.9, 16.8,14.0, 14,14,14,14,12.9,11.9,11.9};
	protected double highYieldCerealPrices[] = {22.5, 22.5, 20.25, 18.0, 15.0,15,15,15,15,13.9,12.7,12.7};
	protected double sunflowerPrices[] = {45.0,20.0,20.0,20.0,20.0,20,20,20,20,17.3,15.3,13.4};
	
	
	public void setYearInfo(YearCount yc){
		super.setYearInfo(yc);
		setPrices();
	}
	
	public void prepareNextStep(){	
		
		super.prepareNextStep();
		setPrices();
	}
	
	protected void setPrices(){
		setPrices(getYear());
	}
	public void setPrices(int year){
		int y = Math.min(Math.max(0,year-baseYear), tradCerealPrices.length-1); //pos in arrays
		//set prices for COP product
		Crop.setPrice(Crop.TRADITIONALCEREALS, tradCerealPrices[y]);
		Crop.setPrice(Crop.HIGHYIELDCEREALS, highYieldCerealPrices[y]);
		Crop.setPrice(Crop.SUNFLOWER, sunflowerPrices[y]);
	}
	
	/**Does nothing.*/
	public void evaluateLandUsePattern(EvaluatedLandUsePattern elp, Farmer f) {

	}
}
