package model.rules;

/** This class has to be re-checked once the rules to be included are better elaborated.*/

import model.*;
import model.decisionMaking.*;


public abstract class Rule {

	protected YearCount yc;
//	protected int year;

	/**Empty method*/
	public void prepareNextStep(){		
	}

	public void setYearInfo(YearCount y){
		yc = y;
	}
	
	public int getYear(){
		return yc.getYear();
	}
	
	
	/**Returns an EvaluatedLandUsePattern containing impacts of this rule added
	 * to those impacts already included in elp. This method must not return null but
	 * if nothing happens in this method should return elp.
	 */ 
	public abstract void evaluateLandUsePattern(EvaluatedLandUsePattern elp, Farmer f);
	
}
