package model.rules;

import model.*;
import model.decisionMaking.EvaluatedLandUsePattern;

public class VineLaw extends Rule {



//	public double efficiencyOfControl = 0.01; 	//0.0-> no control, 1.0->perfect control 
	
	public void prepareNextStep(){	
		if(getYear() == 1997){	//prepareNextStep called before UGBModel.year is increased!?
			yc.setXLabel("-VL");
		}
	}
	
	
	public void evaluateLandUsePattern(EvaluatedLandUsePattern elp, Farmer f) {
		
		// Prohibition of irrigation of vines dropped in 1997
		if(getYear() >= 1997){
			elp.complyWithVineLaw = true;
		}
		else{
		
			LandUsePattern lp;
			LandUse l;
			Farming o;
		
			elp.complyWithVineLaw = true;
			lp = elp.pattern;
			//CHANGE: area of irrigated vine is safed in elp
			elp.irrigatedVine = 0;
			for(int i=0; i<lp.length(); i++) {
				l = lp.get(i);
				o = (Farming)l.option;
				
				//check irrigated areas
				if( (o.getCrop().getType() == Crop.VINEYARDS) && (o.isIrrigated())){
					elp.complyWithVineLaw = false;
					//CHANGE: area of irrigated vine is safed in elp 
					elp.irrigatedVine += l.size;
				}	
			}
		}
	}

}
