package test;

import model.*;
import uchicago.src.sim.util.Random;

public class TestDistances {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		

		Random.createNormal(1.0,1.0);
		Random.createUniform();
		
		//set max Water use manually: sugar beet with flood irrigation
		GlobalVariables.maxWaterUse = 6050 / 0.5;
		
		//define two distinct LandUsePattern
			
		Crop vine = new Crop(Crop.VINEYARDS);
		Crop barley = new Crop(Crop.TRADITIONALCEREALS);
		Crop olives = new Crop(Crop.OLIVES);
		Crop sunflower = new Crop(Crop.SUNFLOWER);
		Crop sugarbeet = new Crop(Crop.SUGARBEET);
		Crop melons = new Crop(Crop.MELONS);
		Crop paprica = new Crop(Crop.PAPRICA);	
		
		IrrigationTechnology drip = new IrrigationTechnology("drip",IrrigationTechnology.DRIP, 0.9);
		IrrigationTechnology sprinkler =  new IrrigationTechnology("sprinkler",IrrigationTechnology.SPRINKLER, 0.75);
		IrrigationTechnology rainfed = new IrrigationTechnology("rainfed",IrrigationTechnology.RAINFED ,1.0);	
		IrrigationTechnology flood = new IrrigationTechnology("flood",IrrigationTechnology.FLOOD ,0.5);
	
		//use dummy farmer
		Farmer f = new Farmer(Farmer.FAMILY, Farmer.MEDIUM2);
		System.out.println("Farm size:"+f.sizeOfFarm);	
		
		Farming dripVine = new Farming(vine,drip);
		Farming sprinklerBarley = new Farming(barley, sprinkler);
		Farming rainfedOlives = new Farming(olives,rainfed);
		Farming sprinklerSunflower = new Farming(sunflower, sprinkler);
		Farming rainfedBarley = new Farming(barley, rainfed);
		Farming sprinklerSugarbeet = new Farming(sugarbeet, sprinkler);
		Farming floodMelons = new Farming(melons, flood);
		Farming dripPaprica = new Farming(paprica, drip);
		

		LandUse l1  = new LandUse();
		l1.size = f.sizeOfFarm;
		l1.option = rainfedOlives; 
		
		LandUse l2  = new LandUse();
		l2.size = f.sizeOfFarm;
		l2.option = sprinklerBarley; 
		
		LandUse l3  = new LandUse();
		l3.size = f.sizeOfFarm;
		l3.option = dripVine; 
		
		LandUse l4  = new LandUse();
		l4.size = f.sizeOfFarm;
		l4.option = dripPaprica; 
		
		LandUse l1_2  = new LandUse();
		l1_2.size = f.sizeOfFarm/2.0;
		l1_2.option = dripPaprica; 
		
		LandUse l2_2  = new LandUse();
		l2_2.size = f.sizeOfFarm/2.0;
		l2_2.option = sprinklerSunflower; 
		
		LandUse l3_2  = new LandUse();
		l3_2.size = f.sizeOfFarm/2.0;
		l3_2.option = floodMelons;
		
		LandUse l4_2  = new LandUse();
		l4_2.size = f.sizeOfFarm/2.0;
		l4_2.option = sprinklerBarley;
		
		LandUse l1_4  = new LandUse();
		l1_4.size = f.sizeOfFarm/4.0;
		l1_4.option = rainfedBarley; 
		
		LandUse l2_4  = new LandUse();
		l2_4.size = f.sizeOfFarm/4.0;
		l2_4.option = sprinklerSugarbeet; 
		
		LandUse l3_4  = new LandUse();
		l3_4.size = f.sizeOfFarm/4.0;
		l3_4.option = dripVine;
		
		LandUse l4_4 = new LandUse();
		l4_4.size = f.sizeOfFarm/4.0;
		l4_4.option = rainfedOlives;
		
		LandUse l5_4 = new LandUse();
		l5_4.size = f.sizeOfFarm/4.0;
		l5_4.option = sprinklerBarley;
		
		LandUse l6_4  = new LandUse();
		l6_4.size = f.sizeOfFarm/4.0;
		l6_4.option = floodMelons;
		
		
		LandUsePattern lpC = new LandUsePattern();
		lpC.add(l2);
//		lpC.add(l2_2);
//		lpC.add(l2_4);
//		lpC.add(l5_4);
		
		LandUsePattern lpF = new LandUsePattern();
//		lpF.add(l4);
//		lpF.add(l2);
		lpF.add(l4_2);
		lpF.add(l3_4);
		lpF.add(l5_4);

		
		f.setInitialLandUsePattern(lpC);
		System.out.println("water capacity of f: "+f.irrigationTech.getWaterCapacity());
		
		//get Distance object to test
		System.out.println("change from: "+lpC.toString());
		System.out.println("to: "+lpF.toString());

		
//		System.out.println("Learning d:"+Distances.getDistanceSkills(lpF, f));
		for(int i=0;i<100;i++)
		System.out.println(Math.min(1.0,Distances.getDistanceCapital(lpF, f)));
		
//		System.out.println("Learning crops d:"+Distances.distanceSkillsCrops(lpF, f));
//		System.out.println("Learning techs d:"+Distances.distanceSkillsTechs(lpF, f));
		
//		System.out.println("Capital techs d:"+Distances.distanceCapitalTechs(lpF, f));
	}
}
