package test;

import model.*;
import model.decisionMaking.*;
import uchicago.src.sim.util.Random;

import java.util.ArrayList;
import java.util.Iterator;

public class TestRefinePattern {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		

		Random.createNormal(1.0,1.0);
		Random.createUniform();
		
		//define two distinct LandUsePattern
			
		Crop vine = new Crop(Crop.VINEYARDS);
		Crop barley = new Crop(Crop.TRADITIONALCEREALS);
		Crop olives = new Crop(Crop.OLIVES);
		Crop sunflower = new Crop(Crop.SUNFLOWER);
		Crop sugarbeet = new Crop(Crop.SUGARBEET);
		Crop melons = new Crop(Crop.MELONS);
		Crop paprica = new Crop(Crop.PAPRICA);	
		
		IrrigationTechnology drip = new IrrigationTechnology("drip",IrrigationTechnology.DRIP, 0.9);
		IrrigationTechnology sprinkler =  new IrrigationTechnology("sprinkler",IrrigationTechnology.SPRINKLER, 0.75);
		IrrigationTechnology rainfed = new IrrigationTechnology("rainfed",IrrigationTechnology.RAINFED ,1.0);	
		IrrigationTechnology flood = new IrrigationTechnology("flood",IrrigationTechnology.FLOOD ,0.5);
	
		//use dummy farmer
		Farmer f = new Farmer(Farmer.FAMILY, Farmer.MEDIUM1);
		System.out.println("Farm size:"+f.sizeOfFarm);	
		
		Farming dripVine = new Farming(vine,drip);
		Farming sprinklerBarley = new Farming(barley, sprinkler);
		Farming rainfedOlives = new Farming(olives,rainfed);
		Farming sprinklerSunflower = new Farming(sunflower, sprinkler);
		Farming rainfedBarley = new Farming(barley, rainfed);
		Farming sprinklerSugarbeet = new Farming(sugarbeet, sprinkler);
		Farming floodMelons = new Farming(melons, flood);
		Farming dripPaprica = new Farming(paprica, drip);
		

		LandUse l1  = new LandUse();
		l1.size = f.sizeOfFarm*0.01;
		l1.option = rainfedOlives; 
		
		LandUse l2  = new LandUse();
		l2.size = f.sizeOfFarm*0.93;
		l2.option = sprinklerBarley; 
		
		LandUse l3  = new LandUse();
		l3.size = f.sizeOfFarm*0.01;
		l3.option = dripVine; 
		
		LandUse l4  = new LandUse();
		l4.size = f.sizeOfFarm*0.01;
		l4.option = dripPaprica; 
		
		LandUse l5  = new LandUse();
		l5.size = f.sizeOfFarm*0.01;
		l5.option = floodMelons; 
		
		LandUse l6  = new LandUse();
		l6.size = f.sizeOfFarm*0.01;
		l6.option = sprinklerSunflower; 
		
		LandUse l7  = new LandUse();
		l7.size = f.sizeOfFarm*0.01;
		l7.option = rainfedBarley; 
		
		LandUse l8  = new LandUse();
		l8.size = f.sizeOfFarm*0.01;
		l8.option = sprinklerSugarbeet; 
		
		
		LandUsePattern lpC = new LandUsePattern();
		lpC.add(l1);
		lpC.add(l2);
		lpC.add(l3);
		lpC.add(l4);
		lpC.add(l5);
		lpC.add(l6);
		lpC.add(l7);
		lpC.add(l8);

		
		f.setInitialLandUsePattern(lpC);
		EvaluatedLandUsePattern elp = new EvaluatedLandUsePattern(lpC);
		
		RefinePattern rp = new RefinePattern();
		ArrayList<EvaluatedLandUsePattern> refined = rp.refine(elp, f);
		
		//Print original and refined pattern
		System.out.println("Original:");
		System.out.println(lpC);
		System.out.println("refined:");
		Iterator<EvaluatedLandUsePattern> it = refined.iterator();
		while(it.hasNext()){
			System.out.println(it.next().pattern);
		}

	}
}
