package test;

import uchicago.src.sim.util.Random;
import model.*;
import model.decisionMaking.*;
import java.util.ArrayList;

public class TestRisk {

	public static void main(String[] args) {
		
		
		Random.createNormal(1.0,1.0);
		Random.createUniform();
		
		//define two distinct LandUsePattern
		
		Crop vine = new Crop(Crop.VINEYARDS);
		Crop barley = new Crop(Crop.TRADITIONALCEREALS);
		Crop olives = new Crop(Crop.OLIVES);
		Crop sunflower = new Crop(Crop.SUNFLOWER);
		Crop sugarbeet =new Crop(Crop.SUGARBEET);
		Crop melons = new Crop(Crop.MELONS);
		Crop paprica = new Crop(Crop.PAPRICA);	
		Crop garlic = new Crop(Crop.GARLIC);
		
		IrrigationTechnology drip = new IrrigationTechnology("drip",IrrigationTechnology.DRIP, 0.9);
		IrrigationTechnology sprinkler =  new IrrigationTechnology("sprinkler",IrrigationTechnology.SPRINKLER, 0.75);
		IrrigationTechnology rainfed = new IrrigationTechnology("rainfed",IrrigationTechnology.RAINFED ,1.0);	
		IrrigationTechnology flood = new IrrigationTechnology("flood",IrrigationTechnology.FLOOD ,0.5);
	
		//use dummy farmer
		Farmer f = new Farmer(Farmer.FAMILY, Farmer.SMALL);
		System.out.println("Farm size:"+f.sizeOfFarm);	
		
		Farming dripVine = new Farming(vine,drip);
		Farming sprinklerBarley = new Farming(barley, sprinkler);
		Farming rainfedOlives = new Farming(olives,rainfed);
		Farming sprinklerSunflower = new Farming(sunflower, sprinkler);
		Farming rainfedBarley = new Farming(barley, rainfed);
		Farming sprinklerSugarbeet = new Farming(sugarbeet, sprinkler);
		Farming floodMelons = new Farming(melons, flood);
		Farming dripPaprica = new Farming(paprica, drip);
		Farming dripGarlic = new Farming(garlic, drip);
		
		//set up global variables
		ArrayList<Farmer>fl = new ArrayList<Farmer>();
		fl.add(f);
		ArrayList<Option> ol = new ArrayList<Option>();
		ol.add(dripVine);
		ol.add(sprinklerBarley);
		ol.add(rainfedOlives);
		ol.add(sprinklerSunflower);
		ol.add(rainfedBarley);
		ol.add(sprinklerSugarbeet);
		ol.add(floodMelons);
		ol.add(dripPaprica);
		ol.add(dripGarlic);
		GlobalVariables.setUp(fl, ol);
		
	
		LandUse l1  = new LandUse();
		l1.size = f.sizeOfFarm;
		l1.option = rainfedOlives; 
		
		LandUse l2  = new LandUse();
		l2.size = f.sizeOfFarm;
		l2.option = sprinklerBarley; 
		
		LandUse l3  = new LandUse();
		l3.size = f.sizeOfFarm;
		l3.option = dripVine; 
		
		LandUse l4 = new LandUse();
		l4.size = 7.4;//f.sizeOfFarm;
		l4.option = dripGarlic;
		
		LandUse l5 = new LandUse();
		l5.size = 0.6;
		l5.option = dripPaprica;
		
		LandUse l1_2  = new LandUse();
		l1_2.size = f.sizeOfFarm/2.0;
		l1_2.option = dripPaprica; 
		
		LandUse l2_2  = new LandUse();
		l2_2.size = f.sizeOfFarm/2.0;
		l2_2.option = sprinklerSunflower; 
		
		LandUse l3_2  = new LandUse();
		l3_2.size = f.sizeOfFarm/2.0;
		l3_2.option = floodMelons;
		
		LandUse l1_4  = new LandUse();
		l1_4.size = f.sizeOfFarm/4.0;
		l1_4.option = rainfedBarley; 
		
		LandUse l2_4  = new LandUse();
		l2_4.size = f.sizeOfFarm/4.0;
		l2_4.option = sprinklerSugarbeet; 
		
		LandUse l3_4  = new LandUse();
		l3_4.size = f.sizeOfFarm/4.0;
		l3_4.option = dripVine;
		
		LandUse l4_4 = new LandUse();
		l4_4.size = f.sizeOfFarm/4.0;
		l4_4.option = rainfedOlives;
		
		LandUse l5_4 = new LandUse();
		l5_4.size = f.sizeOfFarm/4.0;
		l5_4.option = sprinklerBarley;
		
		
		LandUsePattern lp = new LandUsePattern();
		lp.add(l4);
		lp.add(l5);
	//	lp.add(l3_2);
	//	lpC.add(l2_4);
		
		
		model.rules.CapPrices cap = new model.rules.CapPrices();
		cap.setPrices(1990);
		
		
		f.setInitialLandUsePattern(lp);
		System.out.println("Landuse pattern: "+lp.toString());
		
		
		EvaluatedLandUsePattern elp = new EvaluatedLandUsePattern();
		elp.pattern = lp;
		double risk = RiskEvaluation.riskFor(f,elp);
		
//		System.out.println("score gross margin:"+(lp.grossMargin()+elp.penalties())/GlobalVariables.refProfit(f.sizeOfFarm)/f.sizeOfFarm*f.priorityFactors[Farmer.GROSSMARGIN]);
		System.out.println("score risk:"+ risk);
		//	System.out.println("Income:"+lp.income());
	//	System.out.println("risk:"+risk);
	//	System.out.println("Learning d:"+d.distanceLearning(lp3, f));
	//	System.out.println("Capital d:"+d.distanceCapital(lp3, f));
	}
}
