package visualization;

import java.util.ArrayList;
import java.util.Iterator;

import model.Farmer;
import model.GlobalVariables;
import uchicago.src.sim.analysis.OpenSequenceGraph;
import uchicago.src.sim.analysis.Sequence;
import uchicago.src.sim.engine.SimModel;

public class IllegalFarmersChart extends OpenSequenceGraph implements ObserveFarmerChart {

	protected ArrayList<Farmer> farmers;
	protected Sequence illegals;
	protected boolean inited = false;
	
	public IllegalFarmersChart(String title, SimModel model){
		super(title, model, GlobalVariables.getOutputDir()+"IllegalFarmersChart_"+title+GlobalVariables.dataFileExtension, uchicago.src.sim.analysis.PlotModel.CSV);
	}

	public void setFarmersToObserve(ArrayList<Farmer> farmers) {
		this.farmers = farmers;
	}


	public void step() {

		if(! inited){
			illegals = new CountSequence();
			this.addSequence("Nr. of illegals", illegals);
			this.display();
			inited = true;
		}
		this.display();
		super.step();
	}
	
	protected class CountSequence implements Sequence {
				
		public double getSValue(){
			int illegals = 0;
			Farmer f;
			Iterator<Farmer> it = farmers.iterator();
			while(it.hasNext()){
				f = it.next();
				if(f.evaluatedLandUsePattern().violatesLaw()){
					illegals += GlobalVariables.scalingFactor(f.sizeClass);
				}
			}
			return illegals;
		}
	}
}
