package visualization;

import java.util.ArrayList;
import java.util.Iterator;

import model.Farmer;
import model.GlobalVariables;
import uchicago.src.sim.analysis.OpenSequenceGraph;
import uchicago.src.sim.analysis.Plot;
import uchicago.src.sim.engine.SimModel;

public class LabourInputChart extends Plot implements ObserveFarmerChart {

	protected ArrayList<Farmer> farmers;
	
	public LabourInputChart(String title, SimModel model){
		super(title, model);
		this.setConnected(false);
	}

	public void setFarmersToObserve(ArrayList<Farmer> farmers) {
		this.farmers = farmers;
	}


	public void step() {

		int d1 = 0;

		if(farmers != null){
			this.clear(d1);
			Iterator<Farmer> it = farmers.iterator();
			Farmer f;
			while(it.hasNext()){
				f = it.next();
				this.plotPoint(f.sizeOfFarm, f.landUsePattern().labour(), d1);
			}
			
		}
		super.step();
		this.display();

	}
	
	public void setXRange(double min, double max){
		//ignore 
	}
	
	public void writeToFile(){
		//ignore
	}
}
