package visualization;

import java.awt.Color;

import uchicago.src.sim.analysis.plot.OpenGraph;

import model.Farmer;
import model.Farmer_Satisficing;
import model.LandUse;
import model.Option;
import model.Crop;
import model.IrrigationTechnology;
import model.Farming;

public class OptionRepresentation {
	

	
	public static int markStyleForOption(Option o){
		
		if(o instanceof Farming){
			return markStyleForTechType( ((Farming)o).getIrrigationTechnology().getType());			
		}
		return OpenGraph.PLUS_SIGN;

	}
	
	public static int markStyleForTechType(int type){
		
		switch(type){	
			case IrrigationTechnology.RAINFED: return OpenGraph.CROSS;
			case IrrigationTechnology.FLOOD: return OpenGraph.FILLED_SQUARE;
			case IrrigationTechnology.SPRINKLER: return OpenGraph.FILLED_CIRCLE;
			case IrrigationTechnology.DRIP: return OpenGraph.FILLED_DIAMOND;
		}
		return OpenGraph.PLUS_SIGN;
	}
	
	public static Color colorForOption(Option o){
		if(o instanceof Farming){
			return colorForCropType(((Farming)o).getCrop().getType());
		}
		return Color.white;
	}
	
	public static Color colorForCropType(int t){
		
		switch(t){
			case Crop.TRADITIONALCEREALS: return Color.darkGray;
			case Crop.HIGHYIELDCEREALS: return Color.black ;
			case Crop.VINEYARDS: return Color.cyan;
			case Crop.OLIVES: return Color.green;
			case Crop.SUNFLOWER: return Color.lightGray;
			case Crop.SUGARBEET: return Color.pink;
			case Crop.POTATOES: return Color.blue;
			case Crop.MELONS: return Color.red;
			case Crop.PAPRICA: return Color.orange;
			case Crop.GARLIC: return Color.yellow;			
			case Crop.FALLOW: return Color.magenta; 
		}
		return Color.white;
	}
	
	public static Color colorForOutput_Threshold (int t, boolean output){
	switch(t){
		case Farmer_Satisficing.PROFIT:
			if (output) return Color.black;
			else return Color.darkGray;
			
		case Farmer_Satisficing.RISK: 
			if (output) return Color.red;
			else return Color.pink;
			
		case Farmer_Satisficing.LABOUR: 
			if (output) return Color.blue;
			else return Color.CYAN;
			
		case Farmer_Satisficing.LEGALITY: 
			if (output) return Color.orange;
			else return Color.yellow;
	}
	return Color.white;
	}

}
