package visualization;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;

import model.GlobalVariables;
import model.Option;

import uchicago.src.sim.analysis.OpenSequenceGraph;
import uchicago.src.sim.analysis.Sequence;
import uchicago.src.sim.engine.SimModel;


public class TotalUsesChart extends OpenSequenceGraph implements EtcChart{

	protected ArrayList<Option> toObserve;
	protected Hashtable<String,OptionUseSequence> sequences;
	
	public TotalUsesChart(String title, SimModel model){
		super(title, model,GlobalVariables.getOutputDir()+"TotalUses_"+title+GlobalVariables.dataFileExtension,uchicago.src.sim.analysis.PlotModel.CSV);
		sequences = new Hashtable<String,OptionUseSequence>();
	}
	
	public void setObjectsToObserve(ArrayList oList){
		toObserve = new ArrayList<Option>();
		Iterator<Object> it = oList.iterator();
		Object o;
		while(it.hasNext()){
			o = it.next();
//*debug*/			System.err.println("TotalUsesChart: Checking "+o.toString());
			if(o instanceof Option){
				toObserve.add((Option)o);
//*debug*/System.err.println("TotalUsesChart: Adding "+o.toString());
			}
		}
	}
	
	public void step(){
	
		if(toObserve != null){
			Option o;
			Iterator<Option> it = toObserve.iterator();
			while(it.hasNext()){
				o = it.next();
				OptionUseSequence s;
//*debug*/	System.err.println("TotalUsesChart: Check for Sequence for "+o.toString());
				if(! sequences.containsKey(o.getName())){ //use name of LandUse since objects are cloned from time to time
//*debug*/	System.err.println("TotalUsesChart: Create Sequence for "+o.toString());
					s= new OptionUseSequence(o);
					sequences.put(o.getName(), s);
					this.addSequence(o.getName(), s, OptionRepresentation.colorForOption(o),OptionRepresentation.markStyleForOption(o));
					this.display();
				}
			}
		}
		super.step();
	}
	
	protected class OptionUseSequence implements Sequence {
	
		protected Option o;
		
		public OptionUseSequence(Option o){
			this.o = o;
		}
		
		public double getSValue() {
			
			return o.getUses();
		}
	}
}
