package visualization;

import java.util.ArrayList;
import java.util.Iterator;

import model.Farmer;
import model.GlobalVariables;
import uchicago.src.sim.analysis.OpenSequenceGraph;
import uchicago.src.sim.analysis.Sequence;
import uchicago.src.sim.engine.SimModel;

public class WaterExtractionsChart extends OpenSequenceGraph implements ObserveFarmerChart {

	protected ArrayList<Farmer> farmers;
	protected boolean inited = false;
//	protected Sequence area;
	
	public WaterExtractionsChart(String title, SimModel model){
		super(title, model,GlobalVariables.getOutputDir()+"WaterExtractions_"+title+GlobalVariables.dataFileExtension,uchicago.src.sim.analysis.PlotModel.CSV);
	}

	public void setFarmersToObserve(ArrayList<Farmer> farmers) {
		this.farmers = farmers;
	}


	public void step() {

		if(! inited){
			this.addSequence("Extractions (m^3)", new WaterSequence());
			this.display();
			inited = true;
		}
		
		this.display();
		super.step();
	}
	
	protected class WaterSequence implements Sequence {
				
		public double getSValue(){
			double extractions = 0.0;
			Farmer f;
			Iterator<Farmer> it = farmers.iterator();
			while(it.hasNext()){
				f = it.next();
				extractions += f.landUsePattern().waterUsed()*GlobalVariables.scalingFactor(f.sizeClass);
			}
			return extractions;

		}
	}
}
